                                            
''Telescope test 2b

longcon  {timing}

_clkmode = xtal1 + pll1x
_xinfreq = 5_000_000

CLK_FREQ = (_clkmode >> 6) * _xinfreq

MS_001 = CLK_FREQ / 1_000
US_001 = CLK_FREQ / 1_000_000

con  { io pins }

  RX1 = 31 {I}
  TX1 = 30 {O}
  SDR1 = 29 {I/O}
  SCL1 = 28 {I/O}

con  {user io}

  NS_PLS = 16
  NS_Dir = 15
  EW_PLS = 14
  EW_Dir = 13

  BTN_N  =  7
  BTN_E  =  6
  BTN_S  =  5
  BTN_W  =  4

con {navigation}

  NORTH = %1000
  EAST  = %0100
  SOUTH = %0010
  WEST  = %0001

  #0, GO_NORTH, GO_SOUTH
  #0, GO_EAST,  GO_WEST

  CYCLE_TIX = CLK_FREQ / 50
  MOVE  = MS_001 * 15
  MOVES = US_001 * 1950
  STOP  = 0

con

  #true,  on, off
  #false, no, yes

var

  long nspulse
  long ewpulse

obj

  ser: "fullDuplexSerialPlus"
  
pub  main | t, nav

  setup

  ser.start(31, 30, 0, 115200)

  t := cnt
  repeat
    nav :=scan_nav_buttons(5)
    case nav
      NORTH :
        nspulse := MOVE
        outa[NS_Dir] := GO_NORTH
        ewpulse := STOP

      EAST :
        ewpulse := MOVE
        outa[EW_Dir] := GO_EAST
        nspulse := STOP

      SOUTH :
        nspulse := MOVE
        outa[NS_Dir] :=GO_SOUTH
        ewpulse := STOP

      WEST :
        ewpulse := MOVE
        outa[EW_Dir] := GO_WEST
        nspulse := STOP

      other :
        ewpulse := MOVES
        outa[EW_Dir] := GO_WEST
        nspulse := STOP
        

    phsa := -nspulse
    phsb := -ewpulse

    waitcnt (t += CYCLE_TIX)

pub  scan_nav_buttons(ms) : nav | t

  --nav
  t := cnt
  repeat ms
    waitcnt(t += MS_001)
    nav &= (ina[BTN_N] << 3) | (ina[BTN_E] << 2) | (ina[BTN_S] << 1) | ina[BTN_W]

pub  setup

  outa := $00000000
  dira := $00000000

  ctra := %00100 << 26 | NS_PLS
  frqa := 1
  phsa := STOP
  dira[NS_PLS] := 1
  dira[NS_Dir] := 1

  ctrb := %00100 << 26 | EW_PLS
  frqb := 1
  phsb := STOP
  dira[EW_PLS] := 1
  dira[EW_Dir] := 1
        

pub  serial

  repeat
  ser.str(string( "value1 :" ))
  ser.Dec( EW_PLS )
  ser.str(string( "value2 :" ))
  ser.Dec( EW_Dir )
  ser.str(string( "value3 :" ))
  ser.Dec( NS_PLS )
  ser.str(string( "value4 :" ))
  ser.Dec( NS_Dir )
  ser.Tx(13)

  nspulse      := ser.Getlong
  outa[NS_Dir] := ser.Getlong
  ewpulse      := ser.Getlong
  outa[EW_Dir] := ser.Getlong
  